function ApplyBotParts(%c,%b)
{
   %o = %c.player;
   %c.player = %b;
   %c.applyBodyParts();
   %c.applyBodyColors();
   %c.player = %o;
   return %b;
}
function Player::doCorpseClick(%this)
{
   if(isObject(%b=%this.getMountedObject(0))&&%b.corpse)
   {
      %b.dismount();
      %b.addVelocity(vectorScale(%this.getEyeVector(),10));
      %this.playThread(3,"root");
   }
   else
   {
      %start = %this.getEyePoint();
      %targets = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
      %vec =%this.getEyeVector();
      %end = vectorAdd(%start,vectorScale(%vec,10));
      %ray = containerRaycast(%start,%end,%targets,%this);
      %col = firstWord(%ray);
      if(!isObject(%col))
         return;
      if(%col.getClassName()!$="AIPlayer"||!%col.corpse)
         return;
      %this.mountObject(%col,0);
      %col.setTransform("0 0 0 0 0 -1 -1.5709");
      %this.playThread(3,"ArmReadyBoth");
   }
   
}
if(isPackage(ewCorpses))
   deactivatepackage(ewCorpses);
package ewCorpses
{
   function GameConnection::onDeath(%client, %sourceObject, %sourceClient, %damageType, %damageArea) {
      if(!isObject(%client.player))
         return parent::onDeath(%client, %sourceObject, %sourceClient, %damageType, %damageArea);
      %body = new AIPlayer(botCorpse) {datablock = PlayerNoJet;corpse=1;};
      if(!isObject(CorpseGroup)) new SimGroup(CorpseGroup);
      CorpseGroup.add(%body);
		if(isObject(%img = %client.player.getMountedImage(0)))
			%body.mountImage(%img,0);
		%body.setTransform(%client.player.getTransform());
		%client.player.removeBody();
		ApplyBotParts(%client,%body);
		%body.playThread(3,"death1");
		parent::onDeath(%client, %sourceObject, %sourceClient, %damageType, %damageArea);
		%client.camera.setMode("Corpse",%body);
		%client.setControlObject(%client.camera);
      %client.corpse = %body;
      %body.schedule(300000,removeBody);
	}
	function Player::activateStuff(%this)
	{
	   Parent::activateStuff(%this);
	   %this.doCorpseClick();
	}
};
activatepackage(ewCorpses);
function servercmdClearCorpses(%c)
{
   if(!%c.isAdmin)
      return;
   if(!isObject(CorpseGroup))
      return;
   %z=CorpseGroup.getCount();
   if(%z==0)
      return;
   CorpseGroup.chainDeleteAll();
   MessageAll('MsgClearBricks',"\c3"@%c.name@"\c0 cleared corpses ("@%z@")");
}